use axum::extract::State;
use tower_cookies::{Cookies, Cookie};

use std::borrow::Cow;

use crate::state::{
    COOKIE_NAME,
    RoutableAppState,
    sessions::LoggedOutUser,
};

pub async fn route(user: Option<LoggedOutUser>, cookies: Cookies, state: State<RoutableAppState>) -> String {
    if let Some(user) = user {
        let cookie = user.cookie();
        cookies.remove(Cookie::new(Cow::Owned(cookie.name().to_string()), Cow::Owned(cookie.value().to_string())));
        return format!("Goodbye, {}. You are now logged out.", user.username());
    }

    return format!("You are not logged in.");
}
